﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WindowMaxMinDockMgr
{
    public class PaneState
    {
        public enum PaneStateValue { Minimized, Maximized, Normal };
        public PaneState(PaneStateValue state, PaneProxyForm proxyForm, DockerPanel dockerPanel)
        {
            Value = state;
            ProxyForm = proxyForm;
            DockerPanel = dockerPanel;
        }

        public PaneState(PaneStateValue state, DockerPanel dockerPanel)
            : this(state, null, dockerPanel)
        {
        }

        public PaneState(PaneState original, PaneStateValue newState)
            : this(newState, original.ProxyForm, original.DockerPanel)
        {
        }

        public PaneState(PaneState original, PaneProxyForm newProxyForm)
            : this(original.Value, newProxyForm, original.DockerPanel)
        {
        }

        public PaneStateValue Value { get; private set; }
        public PaneProxyForm ProxyForm { get; private set; }
        public DockerPanel DockerPanel { get; private set; }

        public bool IsMinimized { get { return Value == PaneState.PaneStateValue.Minimized; } }
        public bool IsMaximized { get { return Value == PaneState.PaneStateValue.Maximized; } }
        public bool IsNormal { get { return Value == PaneState.PaneStateValue.Normal; } }
        public bool HasProxyForm { get { return ProxyForm != null; } }
    }
}
