﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowMaxMinDockMgr
{
    // This class draws an X from corner to corner to show that the panel 
    // size is correct, unless there is an embedded control.
    public class XPanel : Panel
    {
        public XPanel()
        {
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            if (Controls.Count == 0)
            {
                using (Pen pen = new Pen(Color.Black))
                {
                    Point ul = new Point(ClientRectangle.Left, ClientRectangle.Top);
                    Point lr = new Point(ClientRectangle.Right, ClientRectangle.Bottom);

                    Point ur = new Point(ClientRectangle.Right, ClientRectangle.Top);
                    Point ll = new Point(ClientRectangle.Left, ClientRectangle.Bottom);
                    e.Graphics.DrawLine(pen, ul, lr);
                    e.Graphics.DrawLine(pen, ur, ll);
                }
            }
        }

        protected override void OnResize(EventArgs eventargs)
        {
            base.OnResize(eventargs);
            Invalidate();
        }

        public void SetContent(Control content)
        {
            Controls.Add(content);
        }

        public Control GetContent()
        {
            if (Controls.Count == 0) return null;
            return Controls[0];
        }

        public void ClearContent()
        {
            Controls.Clear();
        }
    }
}
